<?php

use Illuminate\Database\Capsule\Manager as Capsule;

/*if (isset($_SESSION['adminid']) && isset($_REQUEST['action']) && isset($_GET['id']) && isset($_POST['packageconfigoption']) && isset($_POST['servertype']) && $_POST['servertype'] == 'ssl2buy') {*/

if ( isset($_POST['servertype']) && $_POST['servertype'] == 'ssl2buy' && isset($_POST['actionSaveConfig']) && $_POST['actionSaveConfig'] == 'SSL2Buy_setup_configurable_options' ) {
    $id = $_GET['id'];
   
    if($_POST['actionSaveConfig'] == 'SSL2Buy_setup_configurable_options') {
        
        $module = Capsule::table('tblproducts')->where('id', (int) $id)->first();

        if (empty($module)) {
            echo '<script>alert("Product don\'t exist or problem with configuration."); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
        }

        if (empty($_POST['numberOfSans'])) {
            echo '<script>alert("Please set Default number of additional domains"); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
        }

        if ($_POST['numberOfSans'] < 1) {
            echo '<script>alert("Default number of additional domains should be higher than 0"); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
        }

        $productName = $module->name;

        $q = Capsule::table('tblproductconfiglinks')->where('pid', (int) $id)->first();

        $configurableOptionsDefaultName = 'SSL2Buy - ' . $productName . ' - ' . $module->id;

        $flagUpdate = false;
        if (!empty($q)) {
            //remove configurable options
            $groupConfig = Capsule::table('tblproductconfiggroups')->where('name', $configurableOptionsDefaultName)->first();
            $groupId = $groupConfig->id;

            $productConfigOptions = Capsule::table('tblproductconfigoptions')->where('gid', $groupId)->first();
            $configId = $productConfigOptions->id;

            $configOptionsSub = Capsule::table('tblproductconfigoptionssub')->where('configid', $configId)->get();
            foreach ($configOptionsSub as $key => $value) {
                Capsule::table('tblpricing')->where('relid', $value->id)->delete();
            }
            Capsule::table('tblproductconfigoptionssub')->where('configid', $configId)->delete();

            Capsule::table('tblproductconfigoptions')->where('gid', $groupId)->delete();
            Capsule::table('tblproductconfiglinks')->where('gid', $groupId)->where('pid', $id)->delete();
            Capsule::table('tblproductconfiggroups')->where('id', $groupId)->delete();
            Capsule::table('tblproductconfiglinks')->where('gid', $groupId)->where('pid', $id)->delete();

            $flagUpdate = true;
        }

        $san_min = 1;
        $san_max = $_POST['numberOfSans'];

        $price = array();
        $price[] = $_POST['oneYear'];
        $price[] = $_POST['twoYear'];
        $price[] = $_POST['threeYear'];

        $currencyRes = Capsule::table('tblcurrencies')->get();
        $currencyArray = null;
        foreach ($currencyRes as $key => $value) {
            $currencyArray[] = array('id' => $value->id, 'rate' => $value->rate);
        }

        //add new configurableoptions
        $query = 'INSERT INTO tblproductconfigoptions(gid,optionname,optiontype,qtyminimum,qtymaximum,`order`,hidden) VALUES(?,?,1,0,0,0,0)';
        $options_ids = array();

        $query_suboptions = 'INSERT INTO tblproductconfigoptionssub(configid,optionname,sortorder,hidden) VALUES(?,?,0,0)';

        // add options
        $group_id = Capsule::table('tblproductconfiggroups')->insertGetId(
                ['name' => $configurableOptionsDefaultName, 'description' => "Auto generated by module"]
        );

        Capsule::table('tblproductconfiglinks')->insertGetId(
                ['gid' => $group_id, 'pid' => $id]
        );

        $options_ids['sannumber'] = Capsule::table('tblproductconfigoptions')->insertGetId(
                ['gid' => $group_id, 'optionname' => 'sannumber|Number of SAN&#039;s', 'optiontype' => 1, 'qtyminimum' => 0, 'qtymaximum' => 0, 'order' => 0, 'hidden' => 0]
        );

        $id = Capsule::table('tblproductconfigoptionssub')->insertGetId(
                ['configid' => $options_ids['sannumber'], 'optionname' => '0|0', 'sortorder' => 1, 'hidden' => 0]
        );


        foreach ($currencyArray as $currency) {
            Capsule::table('tblpricing')->insertGetId(
                    ['type' => 'configoptions', 'currency' => $currency['id'], 'relid' => $id, 'annually' => 0, 'biennially' => 0, 'triennially' => 0]
            );
        }

        for ($i = $san_min; $i <= $san_max; $i++) {

            $id = Capsule::table('tblproductconfigoptionssub')->insertGetId(
                    ['configid' => $options_ids['sannumber'], 'optionname' => $i . '|' . $i, 'sortorder' => 1, 'hidden' => 0]
            );

            foreach ($currencyArray as $currency) {
                $options = array();
                foreach ($price as $p) {
                    $options[] = (float) ($i * $p) * $currency['rate'];
                }

                Capsule::table('tblpricing')->insertGetId(
                        ['type' => 'configoptions', 'currency' => $currency['id'], 'relid' => $id, 'annually' => 0, 'biennially' => 0, 'triennially' => 0, 'asetupfee' => $options[0], 'bsetupfee' => $options[1], 'tsetupfee' => $options[2]]
                );
            }
        }

        echo '<script>alert("Default Configurable options have been created."); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
    }
}

if ( isset($_POST['servertype']) && $_POST['servertype'] == 'ssl2buy' && isset($_POST['actionSaveWildcardConfig']) && $_POST['actionSaveWildcardConfig'] == 'SSL2Buy_setup_configurable_wildcard_options' ) {
    $id = $_GET['id'];
   
    if($_POST['actionSaveWildcardConfig'] == 'SSL2Buy_setup_configurable_wildcard_options') {
        
        $module = Capsule::table('tblproducts')->where('id', (int) $id)->first();

        if (empty($module)) {
            echo '<script>alert("Product don\'t exist or problem with configuration."); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
        }

        if (empty($_POST['numberOfWildcardSans'])) {
            echo '<script>alert("Please set Default number of additional wildcard domains"); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
        }

        if ($_POST['numberOfWildcardSans'] < 1) {
            echo '<script>alert("Default number of additional wildcard domains should be higher than 0"); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
        }

        $productName = $module->name;

        $q = Capsule::table('tblproductconfiglinks')->where('pid', (int) $id)->first();

        $configurableOptionsDefaultName = 'SSL2Buy - Wildcard - ' . $productName . ' - ' . $module->id;

        $flagUpdate = false;
        if (!empty($q)) {
            //remove configurable options
            $groupConfig = Capsule::table('tblproductconfiggroups')->where('name', $configurableOptionsDefaultName)->first();
            $groupId = $groupConfig->id;

            $productConfigOptions = Capsule::table('tblproductconfigoptions')->where('gid', $groupId)->first();
            $configId = $productConfigOptions->id;

            $configOptionsSub = Capsule::table('tblproductconfigoptionssub')->where('configid', $configId)->get();
            foreach ($configOptionsSub as $key => $value) {
                Capsule::table('tblpricing')->where('relid', $value->id)->delete();
            }
            Capsule::table('tblproductconfigoptionssub')->where('configid', $configId)->delete();

            Capsule::table('tblproductconfigoptions')->where('gid', $groupId)->delete();
            Capsule::table('tblproductconfiglinks')->where('gid', $groupId)->where('pid', $id)->delete();
            Capsule::table('tblproductconfiggroups')->where('id', $groupId)->delete();
            Capsule::table('tblproductconfiglinks')->where('gid', $groupId)->where('pid', $id)->delete();

            $flagUpdate = true;
        }

        $wildcardsan_min = 1;
        $wildcardsan_max = $_POST['numberOfWildcardSans'];

        $price = array();
        $price[] = $_POST['oneYearWildcard'];
        $price[] = $_POST['twoYearWildcard'];
        $price[] = $_POST['threeYearWildcard'];

        $currencyRes = Capsule::table('tblcurrencies')->get();
        $currencyArray = null;
        foreach ($currencyRes as $key => $value) {
            $currencyArray[] = array('id' => $value->id, 'rate' => $value->rate);
        }

        //add new configurableoptions
        $query = 'INSERT INTO tblproductconfigoptions(gid,optionname,optiontype,qtyminimum,qtymaximum,`order`,hidden) VALUES(?,?,1,0,0,0,0)';
        $options_ids = array();

        $query_suboptions = 'INSERT INTO tblproductconfigoptionssub(configid,optionname,sortorder,hidden) VALUES(?,?,0,0)';

        // add options
        $group_id = Capsule::table('tblproductconfiggroups')->insertGetId(
                ['name' => $configurableOptionsDefaultName, 'description' => "Auto generated by module"]
        );

        Capsule::table('tblproductconfiglinks')->insertGetId(
                ['gid' => $group_id, 'pid' => $id]
        );

        $options_ids['wildcardsannumber'] = Capsule::table('tblproductconfigoptions')->insertGetId(
                ['gid' => $group_id, 'optionname' => 'wildcardsannumber|Number of Wildcard SAN&#039;s', 'optiontype' => 1, 'qtyminimum' => 0, 'qtymaximum' => 0, 'order' => 0, 'hidden' => 0]
        );

        $id = Capsule::table('tblproductconfigoptionssub')->insertGetId(
                ['configid' => $options_ids['wildcardsannumber'], 'optionname' => '0|0', 'sortorder' => 1, 'hidden' => 0]
        );


        foreach ($currencyArray as $currency) {
            Capsule::table('tblpricing')->insertGetId(
                    ['type' => 'configoptions', 'currency' => $currency['id'], 'relid' => $id, 'annually' => 0, 'biennially' => 0, 'triennially' => 0]
            );
        }

        for ($i = $wildcardsan_min; $i <= $wildcardsan_max; $i++) {

            $id = Capsule::table('tblproductconfigoptionssub')->insertGetId(
                    ['configid' => $options_ids['wildcardsannumber'], 'optionname' => $i . '|' . $i, 'sortorder' => 1, 'hidden' => 0]
            );

            foreach ($currencyArray as $currency) {
                $options = array();
                foreach ($price as $p) {
                    $options[] = (float) ($i * $p) * $currency['rate'];
                }

                Capsule::table('tblpricing')->insertGetId(
                        ['type' => 'configoptions', 'currency' => $currency['id'], 'relid' => $id, 'annually' => 0, 'biennially' => 0, 'triennially' => 0, 'asetupfee' => $options[0], 'bsetupfee' => $options[1], 'tsetupfee' => $options[2]]
                );
            }
        }

        echo '<script>alert("Default Configurable options have been created."); window.location.href = "configproducts.php?action=edit&id=' . (int) $_REQUEST['id'] . '&tab=3";</script>'; exit();
    }
}


add_hook("ClientAreaHeadOutput", 2, function($params) {

    if (isset($_REQUEST['a']) && $_REQUEST['a'] == 'confproduct') {
        $head_return = '<script type="text/javascript">
            $(document).ready(function(){
                $("#productConfigurableOptions select option").each(function(){
                    var text = $(this).text();
                    var textFixed = text.replace("Setup Fee", ""); 
                    textFixed = textFixed.replace("+", "="); 
                    $(this).text(textFixed);
                });

                $( document ).ajaxComplete(function( event, xhr, settings ) {
                    if(settings.data.indexOf("cyclechange") != -1){
                        $("#productConfigurableOptions select option").each(function(){
                            var text = $(this).text();
                            var textFixed = text.replace("Setup Fee", ""); 
                            textFixed = textFixed.replace("+", "="); 
                            $(this).text(textFixed);
                        });
                    }
                });
            });
        </script>';
        return $head_return;
    }
});

add_hook('AcceptOrder', 1, function($params) {

    if (empty($params['orderid']))
        return false;

    $serviceCheck = Capsule::table('tblsslorders')->where('serviceid', $params['orderid'])->first();

    if (!empty($serviceCheck))
        return false;

    $hosting = Capsule::table('tblhosting')->where('orderid', $params['orderid'])->get();

    if (empty($hosting[0]))
        return false;

    //$admin = Capsule::table('tbladmins')->where('roleid', 1)->limit(1)->get();
    $admin = Capsule::table('tbladmins')->where('roleid', 1)->limit(1)->first();
    
    foreach ($hosting as $key => $value) {
        $values["accountid"] = $value->id;
        localAPI('modulecreate', $values, $admin->username);
    }
});

/*add_hook('AdminAreaHeadOutput', 1, function($params) {

    if ($params['filename'] != 'orders')
        return false;

    $orderId = $_REQUEST['id'];

    $order = Capsule::table('tblsslorders')->where('serviceid', $orderId)->where('module', 'ssl2buy')->first();

    if (!empty($order)) {
        $dataOrderParsed = json_decode($order->configdata);
        $response['orderData'] = $dataOrderParsed;

        $product = Capsule::table('tblhosting')->select('tblproducts.*')->join('tblproducts', 'tblhosting.packageid', '=', 'tblproducts.id')->where('tblhosting.orderid', $orderId)->first();

        $selectedBrandCode = $product->configoption3;

        require_once __DIR__ . '/LibLoader.php';

        $selectedBrandData = SSL2BuyProducts::getBrandByCode($selectedBrandCode);
    }
});*/
?>